package uy.edu.fing.tse.jsf;

import uy.edu.fing.tse.dto.NoticiaDTO;
import uy.edu.fing.tse.dto.PublicacionDTO;
import uy.edu.fing.tse.practico.business.BusinessLocal;

import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.RequestScoped;
import java.util.List;
import java.util.Optional;

@RequestScoped
@ManagedBean(name = "noticiaBean")
public class RequestBean {

    @EJB
    private BusinessLocal negocio;

    @EJB
    private uy.edu.fing.tse.practico.business.mq.JMSProducer jms;

    @ManagedProperty(value = "#{Session}")
    private SessionBean session;


    private Optional<String> tipo = Optional.empty();
    private Optional<String> url = Optional.empty();

    private Optional<String> titulo = Optional.empty();
    private Optional<String> descripcion = Optional.empty();

    public List<NoticiaDTO> getNoticias() {
        return negocio.getNoticias();
    }

    public String getTipo() {
        return tipo.orElse("");
    }

    public void setTipo(String tipo) {
        this.tipo = Optional.ofNullable(tipo);
    }

    public String getUrl() {
        return url.orElse("");
    }

    public void setUrl(String url) {
        this.url = Optional.ofNullable(url);
    }

    public String getTitulo() {
        return titulo.orElse("");
    }

    public void setTitulo(String titulo) {
        this.titulo = Optional.ofNullable(titulo);
    }

    public String getDescripcion() {
        return descripcion.orElse("");
    }

    public void setDescripcion(String descripcion) {
        this.descripcion = Optional.ofNullable(descripcion);
    }

    public SessionBean getSession() {
        return session;
    }

    public void setSession(SessionBean session) {
        this.session = session;
    }

    public String add(long idN) {
        final PublicacionDTO dtoP = new PublicacionDTO(null, tipo.get(), url.get());
        final NoticiaDTO noticiaDTO = negocio.addPublicacionANoticia(dtoP, idN);
        session.setNoticia(noticiaDTO);
        tipo = url = Optional.empty();
        return "noticia";
    }

    public String addNoticia() {
        final int cant = negocio.getNoticias().size();
        jms.altaNoticia(new NoticiaDTO(null, titulo.get(), descripcion.get()));

        for (int i = 0; i < 50; i++) {
            if (cant == negocio.getNoticias().size()) {
                sleep();
            } else {
                break;
            }
        }

        titulo = descripcion = Optional.empty();
        return "getNoticias";
    }

    private void sleep() {
        try {
            Thread.sleep(100);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }
}
