package uy.edu.fing.tse.jsp;

import uy.edu.fing.tse.dto.NoticiaDTO;
import uy.edu.fing.tse.dto.PublicacionDTO;
import uy.edu.fing.tse.practico.business.BusinessLocal;

import javax.ejb.EJB;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

@WebServlet(name = "Controller", urlPatterns = "/jsp/controlador")
public class MyServlet extends HttpServlet {
    private static final long serialVersionUID = -964003102417352102L;

    @EJB
    private BusinessLocal negocio;

    @EJB
    private uy.edu.fing.tse.practico.business.mq.JMSProducer jms;

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        final String noticia = req.getParameter("noticia");
        if (noticia == null) {
            req.setAttribute("noticias", negocio.getNoticias());
            req.getRequestDispatcher("getNoticias.jsp").forward(req, resp);
        } else {
            req.setAttribute("noticia", negocio.findNoticia(Long.parseLong(noticia)));
            req.getRequestDispatcher("verPublicacionesNoticia.jsp").forward(req, resp);
        }
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        final String idNoticia = req.getParameter("idNoticia");

        if (idNoticia == null) {

            final int cant = negocio.getNoticias().size();
            final String descripcion = req.getParameter("descripcion");
            final String titulo = req.getParameter("titulo");

            jms.altaNoticia(new NoticiaDTO(null, titulo, descripcion));

            for (int i = 0; i < 10; i++) {
                if (cant == negocio.getNoticias().size()) {
                    sleep();
                } else {
                    break;
                }
            }

            req.setAttribute("noticias", negocio.getNoticias());
            req.getRequestDispatcher("getNoticias.jsp").forward(req, resp);
        } else {
            final String tipo = req.getParameter("tipo");
            final String url = req.getParameter("url");
            final NoticiaDTO noticia = negocio.addPublicacionANoticia(new PublicacionDTO(null, tipo, url), Long.parseLong(idNoticia));

            req.setAttribute("noticia", noticia);
            req.getRequestDispatcher("verPublicacionesNoticia.jsp").forward(req, resp);
        }

    }

    private void sleep() {
        try {
            Thread.sleep(100);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }
}
